"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var atob = require('atob');
var fs = require('fs');
var jq_1 = require("./jq");
exports.createDir = function (dir) {
    if (!fs.existsSync(dir)) {
        fs.mkdirSync(dir);
    }
    return dir;
};
exports.createFile = function (currentDir, fileName, content) {
    fs.writeFileSync(currentDir + "/" + fileName, content, { flag: 'w' });
};
exports.readFile = function (fileName) {
    var content = fs.readFileSync(fileName, 'utf8');
    return content;
};
exports.createFileIfNotExists = function (currentDir, fileName, content) {
    var file = currentDir + "/" + fileName;
    if (!fs.existsSync(file)) {
        fs.writeFileSync(file, content, { flag: 'w' });
    }
};
function createImage(imgDir, filename, base64) {
    var i = base64.indexOf('base64,');
    var buffer = Buffer.from(base64.slice(i + 7), 'base64');
    fs.writeFileSync(imgDir + "/" + filename, buffer, 'binary');
}
exports.createImage = createImage;
function createSvg(imgDir, src, filename) {
    var base64Image = src.split('data:image/svg+xml;base64,')[1];
    exports.createFile(imgDir, "" + filename, atob(base64Image));
}
exports.createSvg = createSvg;
function createImages(screen, imgDir, styles) {
    screen.find('img').each(function () {
        var src = jq_1.$(this).attr('src');
        var name = jq_1.$(this).attr('class');
        if (styles[name]) {
            var filename = styles[name]['data-filename'];
            if (src.includes('data:image/png')) {
                createImage(imgDir, filename, src);
            }
            if (src.includes('data:image/svg+xml')) {
                createSvg(imgDir, src, filename);
            }
        }
    });
}
exports.createImages = createImages;
