"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var beautify = require("js-beautify");
var values_1 = require("../../../data/values");
var file_1 = require("../../file");
var jq_1 = require("../../jq");
var style_sheet_1 = require("./style-sheet");
exports.generateReactNativeApp = function (compDir, project, component) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        if (component) {
            project.screens.forEach(function (screen) {
                if (screen.name === component) {
                    var web = generateReactNative(screen.name, screen.html, screen.style);
                    file_1.createFile(compDir, screen.name + ".js", web);
                }
            });
        }
        else {
            project.screens.forEach(function (screen) {
                var web = generateReactNative(screen.name, screen.html, screen.style);
                file_1.createFile(compDir, screen.name + ".js", web);
            });
        }
        return [2 /*return*/];
    });
}); };
function generateReactNative(screenId, div, styles) {
    var screen = jq_1.$("<div>" + div + "</div>");
    for (var key in styles) {
        if (styles[key]['element-type']) {
            var type = styles[key]['element-type'];
            if (type == values_1.ElementTypes.Text || type == values_1.ElementTypes.Email) {
                var span = jq_1.$("." + key + " span").first();
                var placeholder = '';
                if (span) {
                    placeholder = span.text();
                    span.remove();
                }
                var tag = "<TextInput class=\"" + key + "\" placeholder='#" + placeholder + "#'>";
                jq_1.$("." + key).replaceWith(tag);
            }
            else if (type == values_1.ElementTypes.Password) {
                var span = jq_1.$("." + key + " span").first();
                var placeholder = '';
                if (span) {
                    placeholder = span.text();
                    span.remove();
                }
                var tag = "<TextInput class=\"" + key + "\" secureTextEntry=\"#\" placeholder='#" + placeholder + "#'>";
                jq_1.$("." + key).replaceWith(tag);
            }
            else if (type == values_1.ElementTypes.Button) {
                jq_1.$("." + key).replaceWith("<TouchableHighlight class=\"" + key + "\" >");
            }
        }
    }
    var html = screen.html();
    html = html.replace(/="#"/g, '');
    html = html.replace(/"#/g, "'");
    html = html.replace(/#"/g, "'");
    html = html.replace(/(data)(.+?)(")/g, '"');
    html = html.replace(/class="/g, 'style={styles.');
    html = html.replace(/src=""/g, 'source={}');
    html = html.replace(/"/g, '}');
    html = html.replace(/div/g, 'View');
    html = html.replace(/span/g, 'Text');
    html = html.replace(/img/g, 'Image');
    html = html.replace(/(source={} >)/g, '/>');
    html = html.replace(/style=""/g, '');
    html = html.replace(/textinput/g, 'TextInput');
    html = html.replace(/touchablehighlight/g, 'TouchableHighlight');
    html = beautify.html(html);
    var react = "import React from 'react';\n";
    react += "import { View,Text,StyleSheet,Image,TextInput,TouchableHighlight } from 'react-native';\n";
    var css = generateNativeStyle(styles);
    react += css + "\n";
    css = beautify.css(css);
    react += "const " + screenId + "Screen = () => {\n";
    react += "return (\n";
    react += html + "\n";
    react += ");\n";
    react += "}\n";
    react += "export default " + screenId + "Screen;\n";
    return react;
}
function generateNativeStyle(styles) {
    var csscode = 'const styles = StyleSheet.create({\n';
    for (var key in styles) {
        csscode += key + ":{\n";
        csscode += getReactNativeStyle(styles[key]);
        csscode += '},\n';
    }
    csscode += '});\n';
    csscode = csscode.replace(/undefined/g, '');
    return csscode;
}
function getReactNativeStyle(elements) {
    var css = '';
    for (var key in elements) {
        if (key && elements[key]) {
            var style = getReactNativeStyleElement(key, elements[key]);
            if (style) {
                css += "    " + style;
            }
        }
    }
    return css;
}
function getReactNativeStyleElement(index, value) {
    var key = getReactNativeKey(index);
    if (key === 'display' || key === 'order')
        return undefined;
    else if (key === 'flex') {
        return key + ':' + value.charAt(0) + ',\n';
    }
    else if (style_sheet_1.styleSheet[key] !== undefined) {
        if (style_sheet_1.styleSheet[key] === 'number') {
            var v = formatSize(value);
            if (v) {
                return key + ":" + formatSize(value) + ",\n";
            }
            return undefined;
        }
        if (style_sheet_1.styleSheet[key] === 'string') {
            if (value) {
                return key + ":'" + value + "',\n";
            }
            return undefined;
        }
    }
    return undefined;
}
function getReactNativeKey(k) {
    var l = k.split('-');
    if (l.length === 1) {
        return k;
    }
    else {
        var s = l[0];
        for (var i = 1; i < l.length; i++) {
            s += l[i].charAt(0).toUpperCase() + l[i].slice(1);
        }
        return s;
    }
}
function formatSize(w) {
    if (typeof w == 'number')
        return w;
    if (w.match(/px/))
        return w.replace('px', '');
    else if (w.match(/%/))
        return "\"" + w.replace('px', '%') + "\"";
    else
        return w;
}
