"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var beautify = require("js-beautify");
var values_1 = require("../../../data/values");
var file_1 = require("../../file");
var jq_1 = require("../../jq");
var style_1 = require("../style");
exports.generateAngularApp = function (compDir, imgDir, project, component) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        if (component) {
            project.screens.forEach(function (screen) {
                if (screen.name === component) {
                    var code = generateAngularHtml(screen, imgDir);
                    file_1.createDir(compDir + "/" + screen.name);
                    file_1.createFile(compDir + "/" + screen.name, screen.name + ".css", code.css);
                    file_1.createFile(compDir + "/" + screen.name, screen.name + ".html", code.html);
                    file_1.createFile(compDir + "/" + screen.name, screen.name + ".js", code.angular);
                }
            });
        }
        else {
            project.screens.forEach(function (screen) {
                var code = generateAngularHtml(screen, imgDir);
                file_1.createDir(compDir + "/" + screen.name);
                file_1.createFile(compDir + "/" + screen.name, screen.name + ".css", code.css);
                file_1.createFile(compDir + "/" + screen.name, screen.name + ".html", code.html);
                file_1.createFile(compDir + "/" + screen.name, screen.name + ".js", code.angular);
            });
        }
        return [2 /*return*/];
    });
}); };
function generateAngularHtml(screen, imgDir) {
    var styles = screen.style;
    var screenId = screen.name;
    var div = screen.html;
    var element = jq_1.$("<div>" + div + "</div>");
    file_1.createImages(element, imgDir, styles);
    var _loop_1 = function (key) {
        if (styles.large[key]['element-type']) {
            var type_1 = styles.large[key]['element-type'];
            if (type_1 == values_1.ElementTypes.Link) {
                element.find("." + key).replaceWith(function () {
                    return jq_1.$("<a class='" + key + "' href='/'/>").append(jq_1.$(this).contents());
                });
            }
            else if (type_1 == values_1.ElementTypes.Email || type_1 == values_1.ElementTypes.Text || type_1 == values_1.ElementTypes.Password) {
                var span = element.find("." + key + " span").first();
                var placeholder_1 = '';
                if (span) {
                    placeholder_1 = span.text();
                    span.remove();
                }
                element.find("." + key).replaceWith(function () {
                    return jq_1.$("<input type='" + type_1 + "' class='" + key + "' placeholder='" + placeholder_1 + "' />").append(jq_1.$(this).contents());
                });
            }
            else if (type_1 == 'component') {
                var classes = [key];
                var elements = element.find("." + key).find('*');
                for (var i = 0; i < elements.length; i++) {
                    classes.push(jq_1.$(elements[i]).attr('class'));
                }
            }
        }
        element.find('img').replaceWith(function () {
            var src = jq_1.$(this).attr('src');
            var name = jq_1.$(this).attr('class');
            if (styles.large[name]) {
                var filename = styles.large[name]['data-filename'];
                if (src.includes('data:image/png')) {
                    return jq_1.$("<img class='" + jq_1.$(this).attr('class') + "' src='../assets/" + filename + "' />");
                }
                if (src.includes('data:image/svg+xml')) {
                    return jq_1.$("<img class='" + jq_1.$(this).attr('class') + "' src='../assets/" + filename + "' />");
                }
            }
            return '';
        });
        setClasses(element, screen.classes);
        var html = element.html();
        for (var key_1 in styles.large) {
            if (styles.large[key_1]['element-type']) {
                var type = styles.large[key_1]['element-type'];
                if (type == values_1.ElementTypes.Component) {
                    var lowerKey = key_1.toLowerCase();
                    var apperKey = style_1.capitalizeFirstLetter(key_1);
                    html = html.replace(new RegExp("<" + lowerKey + ">", 'g'), "<" + apperKey + ">");
                    html = html.replace(new RegExp("</" + lowerKey + ">", 'g'), "</" + apperKey + ">");
                }
            }
        }
        var css = style_1.generateWebStyle(styles, element, screen.classes);
        html = element.html();
        html = beautify.html(html);
        css = beautify.css(css);
        var angular = createTs(screenId);
        angular = beautify.js(angular);
        return { value: { angular: angular, css: css, html: html } };
    };
    for (var key in styles.large) {
        var state_1 = _loop_1(key);
        if (typeof state_1 === "object")
            return state_1.value;
    }
}
function setClasses(screen, classes) {
    var elements = screen.find('*');
    for (var i = 0; i < elements.length; i++) {
        var elementId = jq_1.$(elements[i]).attr('class');
        if (classes && classes[elementId] !== undefined) {
            jq_1.$(elements[i]).attr('class', classes[elementId]);
        }
    }
}
function createTs(screenId) {
    var angular = "\n        import { Component } from '@angular/core';\n        @Component({\n            selector: 'app-" + screenId + "',\n            templateUrl: './" + screenId + ".component.html',\n            styleUrls: ['./" + screenId + ".component.css']\n        })\n        export class " + screenId + "Component {\n            \n        }\n    ";
    return angular;
}
