"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var beautify = require("js-beautify");
var file_1 = require("../file");
var style_1 = require("../style");
var project_1 = require("../../data/project");
var values_1 = require("../../data/values");
var jq_1 = require("../jq");
exports.generateWebApp = function (projectName, component) { return __awaiter(_this, void 0, void 0, function () {
    var data, reactDir, imgDir, compDir;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, project_1.getProject(projectName)];
            case 1:
                data = _a.sent();
                reactDir = process.cwd();
                file_1.createDir(reactDir + "/src");
                imgDir = file_1.createDir(reactDir + "/src/assets");
                compDir = file_1.createDir(reactDir + "/src/components");
                if (component) {
                    data.project.screens.forEach(function (screen) {
                        if (screen.name === component) {
                            generateWebHtml(screen, imgDir, compDir);
                        }
                    });
                }
                else {
                    data.project.screens.forEach(function (screen) {
                        generateWebHtml(screen, imgDir, compDir);
                    });
                }
                return [2 /*return*/];
        }
    });
}); };
function generateWebHtml(screen, imgDir, compDir) {
    var styles = screen.style;
    var screenId = screen.name;
    var div = screen.html;
    var element = jq_1.$("<div>" + div + "</div>");
    file_1.createImages(element, imgDir, styles);
    var _loop_1 = function (id) {
        if (styles.large[id]['element-type']) {
            var type_1 = styles.large[id]['element-type'];
            if (type_1 == values_1.ElementTypes.Link) {
                element.find("." + id).replaceWith(function () {
                    return jq_1.$("<a class='" + id + "' href='/'/>").append(jq_1.$(this).contents());
                });
            }
            else if (type_1 == values_1.ElementTypes.Email || type_1 == values_1.ElementTypes.Text || type_1 == values_1.ElementTypes.Password) {
                var span = element.find("." + id + " span").first();
                var placeholder_1 = '';
                if (span) {
                    placeholder_1 = span.text();
                    span.remove();
                }
                element.find("." + id).replaceWith(function () {
                    return jq_1.$("<input type='" + type_1 + "' class='" + id + "' placeholder='" + placeholder_1 + "' />").append(jq_1.$(this).contents());
                });
            }
        }
    };
    for (var id in styles.large) {
        _loop_1(id);
    }
    element.find('img').replaceWith(function () {
        var src = jq_1.$(this).attr('src');
        var name = jq_1.$(this).attr('class');
        if (styles.large[name]) {
            var filename = styles.large[name]['data-filename'];
            if (src.includes('data:image/png')) {
                return jq_1.$("<img class='" + jq_1.$(this).attr('class') + "' src='./assets/" + filename + "' />");
            }
            if (src.includes('data:image/svg+xml')) {
                return jq_1.$("<img class='" + jq_1.$(this).attr('class') + "' src='./assets/" + filename + "' />");
            }
        }
        return '';
    });
    setClasses(element, screen.classes);
    var html = "<html>\n                <head>\n                <title>" + screenId + "</title>\n                <link rel = 'stylesheet'\n                  type = 'text/css'\n                  href = '" + screenId + ".css' />\n                </head>\n                <body>";
    html += element.html();
    html += "</body>";
    html += "</html>";
    html = beautify.html(html);
    var css = style_1.generateWebStyle(styles, element, screen.classes);
    css = beautify.css(css);
    file_1.createFile(compDir, screenId + ".css", css);
    file_1.createFile(compDir, screenId + ".html", html);
}
function setClasses(screen, classes) {
    var elements = screen.find('*');
    for (var i = 0; i < elements.length; i++) {
        var elementId = jq_1.$(elements[i]).attr('class');
        if (classes && classes[elementId] !== undefined) {
            jq_1.$(elements[i]).attr('class', classes[elementId]);
        }
    }
}
