"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var beautify = require("js-beautify");
var _ = require("lodash");
var values_1 = require("../../../../data/values");
var file_1 = require("../../../file");
var jq_1 = require("../../../jq");
var style_1 = require("../../style");
exports.generateStyledReactApp = function (compDir, imgDir, project, component) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        if (component) {
            project.screens.forEach(function (screen) {
                if (screen.name === component) {
                    var code = generateStyledReact(screen, imgDir);
                    file_1.createFile(compDir, screen.name + ".js", code);
                }
            });
        }
        else {
            project.screens.forEach(function (screen) {
                var code = generateStyledReact(screen, imgDir);
                file_1.createFile(compDir, screen.name + ".js", code);
            });
        }
        return [2 /*return*/];
    });
}); };
function generateStyledReact(screen, imgDir) {
    var components = [];
    var $screen = _.cloneDeep(screen);
    var styles = $screen.style.large;
    var screenId = $screen.name;
    var div = $screen.html;
    var comp = jq_1.$("<div>" + div + "</div>");
    file_1.createImages(comp, imgDir, styles);
    var _loop_1 = function (key) {
        if (styles[key]['element-type']) {
            var type_1 = styles[key]['element-type'];
            if (type_1 == values_1.ElementTypes.Link) {
                comp.find("." + key).replaceWith(function () {
                    return jq_1.$("<a class='" + key + "' href='/'/>").append(jq_1.$(this).contents());
                });
            }
            else if (type_1 == values_1.ElementTypes.Email || type_1 == values_1.ElementTypes.Text || type_1 == values_1.ElementTypes.Password) {
                var span = comp.find("." + key + " span").first();
                var spanClass = span.attr('class');
                var placeholder_1 = '';
                if (span) {
                    placeholder_1 = span.text();
                    span.remove();
                }
                delete styles[spanClass];
                comp.find("." + key).replaceWith(function () {
                    return jq_1.$("<input type='" + type_1 + "' class='" + key + "' placeholder='" + placeholder_1 + "' #tag/>").append(jq_1.$(this).contents());
                });
            }
            else if (type_1 == values_1.ElementTypes.Component) {
                var classes = [key];
                var elements = comp.find("." + key).find('*');
                for (var i = 0; i < elements.length; i++) {
                    classes.push(jq_1.$(elements[i]).attr('class'));
                }
            }
        }
    };
    for (var key in styles) {
        _loop_1(key);
    }
    $screen.style.large = styles;
    var _a = transform(comp, $screen.style, $screen.classes, components), html = _a.html, css = _a.css;
    var react = createJs(html, screenId, css);
    return react;
}
function transform(comp, style, classes, components) {
    if (components === void 0) { components = null; }
    comp.find('img').replaceWith(function () {
        var src = jq_1.$(this).attr('src');
        var name = jq_1.$(this).attr('class');
        var filename = style.large[name]['data-filename'];
        if (src.includes('data:image/png')) {
            return jq_1.$("<img class=\"" + jq_1.$(this).attr('class') + "\" src=\"../assets/" + filename + "\"  alt=\"\"  #tag/>");
        }
        if (src.includes('data:image/svg+xml')) {
            return jq_1.$("<img class=\"" + jq_1.$(this).attr('class') + "\" src=\"../assets/" + filename + "\"  alt=\"\"  #tag/>");
        }
        return '';
    });
    setClasses(comp, classes);
    var css = generateStyledReactCss(style, comp, classes);
    var _loop_2 = function (key) {
        comp.find("." + key).replaceWith(function () {
            return jq_1.$("<" + key + "/>").append(jq_1.$(this).contents());
        });
    };
    for (var key in style.large) {
        _loop_2(key);
    }
    if (classes) {
        var _loop_3 = function (key) {
            var className = classes[key];
            comp.find("." + className).replaceWith(function () {
                return jq_1.$("<" + className + "/>").append(jq_1.$(this).contents());
            });
        };
        for (var key in classes) {
            _loop_3(key);
        }
    }
    var html = comp.html();
    if (classes) {
        for (var key in classes) {
            var className = classes[key];
            var lowerKey = _.cloneDeep(className).toLowerCase();
            html = html.replace(new RegExp("<" + lowerKey + ">", 'g'), "<" + style_1.firstLetterUpper(className) + ">");
            html = html.replace(new RegExp("</" + lowerKey + ">", 'g'), "</" + style_1.firstLetterUpper(className) + ">");
        }
    }
    for (var key in style.large) {
        var lowerKey = _.cloneDeep(key).toLowerCase();
        html = html.replace(new RegExp("<" + lowerKey + ">", 'g'), "<" + style_1.firstLetterUpper(key) + ">");
        html = html.replace(new RegExp("</" + lowerKey + ">", 'g'), "</" + style_1.firstLetterUpper(key) + ">");
    }
    if (components) {
        for (var _i = 0, components_1 = components; _i < components_1.length; _i++) {
            var key = components_1[_i];
            var lowerKey = _.cloneDeep(key).toLowerCase();
            html = html.replace(new RegExp("<" + lowerKey + ">", 'g'), "<" + style_1.firstLetterUpper(key) + ">");
            html = html.replace(new RegExp("</" + lowerKey + ">", 'g'), "</" + style_1.firstLetterUpper(key) + ">");
        }
    }
    html = html.replace(/#tag="">/g, '/>');
    html = html.replace(/href/g, 'to');
    html = beautify.html(html);
    css = beautify.css(css);
    return { html: html, css: css };
}
function setClasses(screen, classes) {
    var elements = screen.find('*');
    for (var i = 0; i < elements.length; i++) {
        var elementId = jq_1.$(elements[i]).attr('class');
        if (classes && classes[elementId] !== undefined) {
            jq_1.$(elements[i]).attr('class', classes[elementId]);
        }
    }
}
function createJs(html, screenId, css) {
    var react = "import React from 'react';\n";
    react += "import styled from 'styled-components';\n";
    react += css + "\n";
    react += "const " + style_1.firstLetterUpper(screenId) + "Component = () => {\n";
    react += "return (\n";
    react += html + "\n";
    react += ");\n";
    react += "}\n";
    react += "export default " + style_1.firstLetterUpper(screenId) + "Component;\n";
    return react;
}
function generateStyledReactCss(styles, screen, classes) {
    var csscode = '';
    var keys = [];
    for (var key in styles.large) {
        var style = styles.large[key];
        if (classes[key] != undefined && classes[key] != '') {
            key = classes[key];
        }
        if (screen.find("." + key)[0]) {
            var tag = screen.find("." + key)[0].tagName.toLowerCase();
            csscode += "const " + style_1.firstLetterUpper(key) + " =styled." + tag + "`{\n";
            csscode += style_1.getCss(style);
            if (styles.medium && styles.medium[key]) {
                csscode += "@media only screen and (max-width: 1024px)  {\n          " + style_1.getCss(styles.medium[key]) + "\n        }\n";
            }
            if (styles.small && styles.small[key]) {
                csscode += "@media only screen and (max-width: 540px)  {\n          " + style_1.getCss(styles.small[key]) + "\n        }\n";
            }
            csscode += '}`;\n';
        }
        keys.concat(key);
    }
    return csscode;
}
