"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var file_1 = require("../code/file");
var react_native_1 = require("../code/mobile/reactnative/react-native");
var angular_1 = require("../code/web/angular/angular");
var html5_1 = require("../code/web/html/html5");
var generate_react_1 = require("../code/web/react/generate-react");
var vue_1 = require("../code/web/vue/vue");
var project_1 = require("../data/project");
var project_2 = require("../settings/project");
exports.builder = function (yargs) {
    yargs
        .option('projectId', {
        describe: 'Enter the project Id',
        type: 'string',
    })
        .option('component', {
        describe: 'Enter the component name',
        type: 'string',
    })
        .option('type', {
        describe: 'Enter the project type:module,inline,styled,web,reactNative',
        type: 'string',
    })
        .option('style', {
        describe: 'Enter the style type(only for react projects) :module,inline,styled,aphrodite,emotion,jss,radium',
        type: 'string',
    })
        .help().argv;
};
exports.handler = function (args) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, generate(args)];
                case 1:
                    _a.sent();
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    });
};
var generate = function (args) {
    return __awaiter(this, void 0, void 0, function () {
        var settings, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, getSettings(args)];
                case 1:
                    settings = _b.sent();
                    _a = settings.type.toLowerCase();
                    switch (_a) {
                        case 'web': return [3 /*break*/, 2];
                        case 'react': return [3 /*break*/, 4];
                        case 'reactnative': return [3 /*break*/, 6];
                        case 'vue': return [3 /*break*/, 8];
                        case 'angular': return [3 /*break*/, 10];
                    }
                    return [3 /*break*/, 12];
                case 2: return [4 /*yield*/, html5_1.generateWebApp(settings.compDir, settings.imgDir, settings.project, settings.component)];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 4: return [4 /*yield*/, generate_react_1.generateReactApp(settings.compDir, settings.imgDir, settings.project, settings.component, settings.style)];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 6: return [4 /*yield*/, react_native_1.generateReactNativeApp(settings.compDir, settings.project, settings.component)];
                case 7:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 8: return [4 /*yield*/, vue_1.generateVueApp(settings.compDir, settings.imgDir, settings.project, settings.component)];
                case 9:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 10: return [4 /*yield*/, angular_1.generateAngularApp(settings.compDir, settings.imgDir, settings.project, settings.component)];
                case 11:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 12:
                    process.exit(0);
                    _b.label = 13;
                case 13: return [2 /*return*/];
            }
        });
    });
};
var getSettings = function (args) { return __awaiter(_this, void 0, void 0, function () {
    var imgDir, compDir, projectId, style, component, type, dir, settings, project, ob;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                dir = process.cwd();
                settings = project_2.readSettings();
                projectId = settings && settings.projectId ? settings.projectId : args.projectId;
                type = settings && settings.type ? settings.type : args.type;
                style = settings && settings.style ? settings.style : args.style;
                if (settings && settings.imgDir) {
                    imgDir = dir + "/" + settings.imgDir;
                }
                else {
                    file_1.createDir(dir + "/src");
                    imgDir = file_1.createDir(dir + "/public/assets");
                }
                if (settings && settings.compDir) {
                    compDir = dir + "/" + settings.compDir;
                }
                else {
                    file_1.createDir(dir + "/src");
                    compDir = file_1.createDir(dir + "/src/components");
                }
                return [4 /*yield*/, project_1.readProject(projectId)];
            case 1:
                project = _a.sent();
                component = args.component;
                ob = {
                    project: project,
                    style: style,
                    component: component,
                    type: type,
                    compDir: compDir,
                    imgDir: imgDir,
                };
                return [2 /*return*/, ob];
        }
    });
}); };
