"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var auth_1 = require("@aws-amplify/auth");
var core_1 = require("@aws-amplify/core");
var amazon_cognito_identity_js_1 = require("amazon-cognito-identity-js");
var Configstore = require('configstore');
var pkg = require('../../package.json');
var conf = new Configstore(pkg.name, { token: '', refreshToken: '', userId: '' });
var USER_POOL_ID = 'us-east-2_ixcAGkaCo';
var CLIENT_ID = '29of4a1bjtlbaqccroukh0l19i';
core_1.default.configure({
    Auth: {
        identityPoolId: 'us-east-2:aa26ccf3-b3c3-4957-a59a-f7bdef3114d7',
        region: 'us-east-2',
        userPoolId: USER_POOL_ID,
        userPoolWebClientId: CLIENT_ID,
    },
});
var getCognitoUser = function (userName) {
    var poolData = {
        UserPoolId: USER_POOL_ID,
        ClientId: CLIENT_ID,
    };
    var userPool = new amazon_cognito_identity_js_1.CognitoUserPool(poolData);
    var userData = {
        Username: userName,
        Pool: userPool,
    };
    return new amazon_cognito_identity_js_1.CognitoUser(userData);
};
var getSession = function () {
    return {
        idToken: conf.get('token'),
        refreshToken: conf.get('refreshToken'),
        userName: conf.get('userName'),
    };
};
var setSession = function (session, userName) {
    conf.set('token', session.idToken.jwtToken);
    conf.set('refreshToken', session.refreshToken.token);
    conf.set('userName', userName);
};
var signIn = function (email, password) {
    return __awaiter(this, void 0, void 0, function () {
        var user, session, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, auth_1.default.signIn(email, password)];
                case 1:
                    user = _a.sent();
                    return [4 /*yield*/, auth_1.default.currentSession()];
                case 2:
                    session = _a.sent();
                    setSession(session, user.username);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    throw err_1;
                case 4: return [2 /*return*/];
            }
        });
    });
};
exports.signIn = signIn;
var generateSession = function () {
    var session = getSession();
    if (session.refreshToken !== undefined && session.refreshToken !== null) {
        var RefreshToken_1 = new amazon_cognito_identity_js_1.CognitoRefreshToken({ RefreshToken: session.refreshToken });
        var cognitoUser_1 = getCognitoUser(session.userName);
        return new Promise(function (resolve, reject) {
            cognitoUser_1.refreshSession(RefreshToken_1, function (err, data) {
                if (err) {
                    conf.clear();
                    reject(err);
                }
                else {
                    setSession(data, session.userName);
                    resolve();
                }
            });
        });
    }
};
var refreshSession = function () {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, generateSession()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
};
exports.refreshSession = refreshSession;
