const atob = require('atob');
const fs = require('fs');
import { $ } from './jq';
export const createDir = dir => {
  if (!fs.existsSync(dir)) {
    fs.mkdirSync(dir);
  }
  return dir;
};

export const createFile = (currentDir, fileName, content) => {
  fs.writeFileSync(`${currentDir}/${fileName}`, content, { flag: 'w' });
};

export const readFile = fileName => {
  const content = fs.readFileSync(fileName, 'utf8');
  return content;
};

export const createFileIfNotExists = (currentDir, fileName, content) => {
  let file = `${currentDir}/${fileName}`;
  if (!fs.existsSync(file)) {
    fs.writeFileSync(file, content, { flag: 'w' });
  }
};

export function createImage(imgDir, filename, base64) {
  const i = base64.indexOf('base64,');
  const buffer = Buffer.from(base64.slice(i + 7), 'base64');
  fs.writeFileSync(`${imgDir}/${filename}`, buffer, 'binary');
}

export function createSvg(imgDir, src, filename) {
  let base64Image = src.split('data:image/svg+xml;base64,')[1];
  createFile(imgDir, `${filename}`, atob(base64Image));
}

export function createImages(screen, imgDir, styles) {
  screen.find('img').each(function(this) {
    let src = $(this).attr('src');
    let name = $(this).attr('class');
    if (styles[name]) {
      let filename = styles[name]['data-filename'];
      if (src.includes('data:image/png')) {
        createImage(imgDir, filename, src);
      }
      if (src.includes('data:image/svg+xml')) {
        createSvg(imgDir, src, filename);
      }
    }
  });
}
