import { generateAphroditeReactApp } from './aphrodite/react-aphrodite';
import { generateEmotionReactApp } from './emotion/react-emotion';
import { generateInlineReactApp } from './inline/react-inline';
import { generateJssReactApp } from './jss/react-jss';
import { generateReactModuleApp } from './module/react';
import { generateRadiumReactApp } from './radium/react-radium';
import { generateStyledReactApp } from './styled/styled-react';

export const generateReactApp = async function(compDir, imgDir, project, component, style) {
  if (style === undefined || style === null || style === '') {
    await generateReactModuleApp(compDir, imgDir, project, component);
    return;
  }
  switch (style.toLowerCase()) {
    case 'aphrodite':
      await generateAphroditeReactApp(compDir, imgDir, project, component);
      break;
    case 'emotion':
      await generateEmotionReactApp(compDir, imgDir, project, component);
      break;
    case 'inline':
      await generateInlineReactApp(compDir, imgDir, project, component);
      break;
    case 'jss':
      await generateJssReactApp(compDir, imgDir, project, component);
      break;
    case 'module':
      await generateReactModuleApp(compDir, imgDir, project, component);
      break;
    case 'radium':
      await generateRadiumReactApp(compDir, imgDir, project, component);
      break;
    case 'styled':
      await generateStyledReactApp(compDir, imgDir, project, component);
      break;
    default:
      process.exit(0);
  }
};
