import { getProject } from '../data/project';
import { readSettings } from '../settings/project';
export const builder = yargs => {
  yargs
    .option('projectId', {
      describe: 'Enter the project Id',
      type: 'string',
    })
    .help().argv;
};
export const handler = async function(args) {
  await get(args);
  process.exit(0);
};

let get = async args => {
  let settings = readSettings();
  let projectId = settings && settings.projectId ? settings.projectId : args.projectId;
  await getProject(projectId);
};
