import * as inquirer from 'inquirer';
import { writeSettings } from '../settings/project';

export const builder = yargs => {};

export const handler = async function(args) {
  const command = args._[0];
  switch (command) {
    case 'init':
      const settings = await enterSettings();
      await writeSettings(settings);
      break;
  }
  process.exit(0);
};
let enterSettings = function() {
  const questions = [
    {
      name: 'projectId',
      type: 'input',
      message: 'Enter  project id:',
    },
    {
      name: 'type',
      type: 'list',
      message: 'Enter  project type:',
      choices: ['react', 'angular', 'vue', 'web', 'reactNative'],
    },
    {
      type: 'list',
      name: 'style',
      message: 'Enter styling choice:',
      choices: ['module', 'inline', 'styled', 'aphrodite', 'jss', 'radium'],
      when: answers => answers.type === 'react',
    },
    {
      name: 'compDir',
      type: 'input',
      message: 'Enter components directory:',
    },
    {
      name: 'imgDir',
      type: 'input',
      message: 'Enter assets directory:',
    },
  ];
  return inquirer.prompt(questions);
};
