import axios from 'axios';
import * as Configstore from 'configstore';
import * as tempDirectory from 'temp-dir';
import { createFile, readFile } from '../code/file.js';
import { refreshSession } from './auth.js';
import { Config } from './config';
const pkg = require('../../package.json');
const atob = require('atob');
const conf = new Configstore(pkg.name);
export const getProject = async function(id) {
  await refreshSession();
  let config = {
    headers: { authorization: conf.get('token') },
  };
  try {
    let response = await axios.get(`${Config.prod.API_URL}/projects/${id}`, config);
    let file = await axios.get(response.data.signedUrl);
    createFile(tempDirectory, `${id}.fl`, file.data);
  } catch (error) {
    console.error(error);
    process.exit(0);
  }
};
export const readProject = function(id) {
  let content = readFile(`${tempDirectory}/${id}.fl`);
  let strProject = atob(content);
  let project = JSON.parse(strProject);
  return project;
};
