import { createDir, createFileIfNotExists, readFile } from '../code/file';
const fs = require('fs');
export const writeSettings = settings => {
  let dir = createDir(`${process.cwd()}/.fl`);
  createFileIfNotExists(dir, `settings.json`, JSON.stringify(settings));
};

export const readSettings = () => {
  let dir = process.cwd();
  const file = `${dir}/.fl/settings.json`;
  if (fs.existsSync(file)) {
    let content = readFile(file);
    const settings = JSON.parse(content);
    return settings;
  }
  return undefined;
};
